package com.loafle.overflow.module.discovery.service;

import java.util.Date;

import com.loafle.overflow.module.core.annotation.ProbeAPI;
import com.loafle.overflow.module.core.annotation.WebappAPI;
import com.loafle.overflow.module.core.exception.OverflowException;
import com.loafle.overflow.module.discovery.model.DiscoverHost;
import com.loafle.overflow.module.discovery.model.DiscoverPort;
import com.loafle.overflow.module.discovery.model.DiscoverService;
import com.loafle.overflow.module.discovery.model.DiscoverZone;
import com.loafle.overflow.module.discovery.model.Host;
import com.loafle.overflow.module.discovery.model.Port;
import com.loafle.overflow.module.discovery.model.Service;
import com.loafle.overflow.module.discovery.model.Zone;

/**
 * Created by snoop on 17. 9. 28.
 */
public interface DiscoveryService {
  @WebappAPI
  void discoverZone(String probeID, DiscoverZone discoverZone) throws OverflowException;
  @WebappAPI
  void discoverHost(String probeID, Zone zone, DiscoverHost discoverHost) throws OverflowException;
  @WebappAPI
  void discoverPort(String probeID, Host host, DiscoverPort discoverPort) throws OverflowException;
  @WebappAPI
  void discoverService(String probeID, Port port, DiscoverService discoverService) throws OverflowException;

  @ProbeAPI
  void discoverStart(String requesterSessionID, Date startDate) throws OverflowException;
  @ProbeAPI
  void discoverStop(String requesterSessionID, Date stopDate) throws OverflowException;
  @ProbeAPI
  void discoveredZone(String requesterSessionID, Zone zone) throws OverflowException;
  @ProbeAPI
  void discoveredHost(String requesterSessionID, Host host) throws OverflowException;
  @ProbeAPI
  void discoveredPort(String requesterSessionID, Port port) throws OverflowException;
  @ProbeAPI
  void discoveredService(String requesterSessionID, Service service) throws OverflowException;
}
