package com.loafle.overflow.module.meta.model;


import javax.persistence.*;
import java.util.Date;

/**
 * Created by insanity on 17. 9. 20.
 */
@Entity
@Table(name = "META_SENSOR_DISPLAY_ITEM", schema = "public")
public class MetaSensorDisplayItem {

    private long id;
    private String name;
    private MetaCrawler crawler;
    private MetaSensorItemUnit unit;
    private Date createDate;
    private MetaSensorItemType itemType;

    @Id
    @GeneratedValue(strategy= GenerationType.IDENTITY)
    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    @Column(name = "NAME", nullable = false, length = 50)
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @ManyToOne
    @JoinColumn(name = "CRAWLER_ID", nullable = false)
    public MetaCrawler getCrawler() {
        return crawler;
    }

    public void setCrawler(MetaCrawler crawler) {
        this.crawler = crawler;
    }

    @ManyToOne
    @JoinColumn(name = "UNIT_ID", nullable = true)
    public MetaSensorItemUnit getUnit() {
        return unit;
    }

    public void setUnit(MetaSensorItemUnit unit) {
        this.unit = unit;
    }

    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
    public Date getCreateDate() {
        return createDate;
    }

    public void setCreateDate(Date createDate) {
        this.createDate = createDate;
    }


    @ManyToOne
    @JoinColumn(name = "TYPE_ID", nullable = false)
    public MetaSensorItemType getItemType() {
        return itemType;
    }

    public void setItemType(MetaSensorItemType itemType) {
        this.itemType = itemType;
    }
}
