package com.loafle.overflow.module.notification.service;

import com.loafle.overflow.module.core.annotation.WebappAPI;
import com.loafle.overflow.module.core.exception.OverflowException;
import com.loafle.overflow.module.core.model.PageParams;
import com.loafle.overflow.module.member.model.Member;
import com.loafle.overflow.module.notification.model.Notification;
import org.springframework.data.domain.Page;
/**
 * Created by insanity on 17. 8. 25.
 */
public interface NotificationService {
    @WebappAPI
    Notification regist(Notification notification) throws OverflowException;
    @WebappAPI
    Page<Notification> readAllByMember(Member member, PageParams pageParams) throws OverflowException;
    @WebappAPI
    Page<Notification> readAllUnconfirmedByMember(Member member,  PageParams pageParams) throws OverflowException;
    @WebappAPI
    int readUnconfirmedCount(Member member) throws OverflowException;
    @WebappAPI
    Page<Notification> markAllAsRead(Member member, PageParams pageParams) throws OverflowException;
    @WebappAPI
    Page<Notification> markAllAsUnread(Member member, PageParams pageParams) throws OverflowException;
    @WebappAPI
    Notification markAsRead(Notification notification) throws OverflowException;
}
